#include "gbaspc.h"

void Isr() {
	unsigned int interrupts = INTACK;

	if (interrupts & INT_TIMER(1)) {
		// Swap buffers
		DMA[1].control = 0;

		// Let the DMA catch up
		__asm volatile ("eor r0, r0, r0" ::: "r0");

		DMA[1].src = soundBuffer + (curSoundBuffer * MIXBUFSIZE);
		DMA[1].dst = (void *)0x040000a0; /* write to FIFO A address */
		DMA[1].count = 1;
		DMA[1].control = DMA_DSTUNCH | DMA_SRCINC | DMA_REPEAT | DMA_U32 | DMA_SPECIAL;

		curSoundBuffer = 1 - curSoundBuffer;
		MixMono(soundBuffer + (curSoundBuffer * MIXBUFSIZE));
	}

	BIOS_INTACK |= interrupts;
	INTACK = interrupts;
	INTENABLE = 1;
}
