#include "gbaspc.h"

s32 mixBuffer[MIXBUFSIZE];

void DspMixOneChannel(u32 numSamples,DspChannel *channel,s32 *buffer) CODE_IN_IWRAM;
void DspDownSample(s32 *sourceBuffer, u8 *outBuffer, u32 numSamples) CODE_IN_IWRAM;

void MixMono(u8 *outBuffer) {
	DspSetupMixer();

	CpuFastClear(0, mixBuffer, MIXBUFSIZE);

	for (int channel = 0; channel < 8; channel++) {
		if (!channels[channel].active) continue;

		DspMixOneChannel(MIXBUFSIZE, &(channels[channel]), mixBuffer);

		if (channels[channel].active == 0) {
			if (channels[channel].flags == 0) {
				DSP_MEM[DSP_KON] &= ~(1 << channel);
			} else {
				channels[channel].active = 1;
			}
			DSP_MEM[DSP_ENDX] |= 1 << channel;
		}
/*
		if (APU_MEM[0xF2] == ((channel << 4) | DSP_ENVX)) {
			APU_MEM[0xF3]++; // = DSP_MEM[(channel << 4) | DSP_ENVX] = ;
		} else if (APU_MEM[0xF2] == ((channel << 4) | DSP_OUTX)) {
			APU_MEM[0xF3]++;// = DSP_MEM[(channel << 4) | DSP_OUTX] = channels[channel].volume;
		}*/
	}
	// Called roughly 61 times a second
	cyclesToExecute += spcCyclesPerSec / 64;

	DspDownSample(mixBuffer, outBuffer, MIXBUFSIZE);
}

