#include "stdafx.h"

void GenerateInstructionSetHeader(FILE *outFile);

void RegenInst() {
	FILE *file = fopen("armOps.h","wt");
	GenerateInstructionSetHeader(file);
	fclose(file);
}

void GenerateMemWriteLUT() {
	FILE *file = fopen("memwritelut.h","wt");
	fprintf(file, "const u32 memWriteLUT[0x100] = {\n");
	for (int i=0; i<=0xFF; i++) {
		fprintf(file, "// 0x%.4x\n",i);
		switch (i) {
		case 0xf1:
			fprintf(file, "(u32)(&MemWriteApuControl)");
			break;
		case 0xf2:
			fprintf(file, "(u32)(&MemWriteDspAddress)");
			break;
		case 0xf3:
			fprintf(file, "(u32)(&MemWriteDspData)");
			break;
		default:
			fprintf(file, "(u32)(&MemWriteDoNothing)");
			break;
		}
		if (i == 0xFF) fprintf(file, "\n"); else fprintf(file, ",\n");
	}
	fprintf(file, "};\n");
	fclose(file);
}

void GenerateMemReadLUT() {
	FILE *file = fopen("memreadlut.h","wt");
	fprintf(file, "const u32 memReadLUT[0x100] = {\n");
	for (int i=0; i<=0xFF; i++) {
		fprintf(file, "// 0x%.4x\n",i);
		switch (i) {
		case 0xFD:
			fprintf(file, "(u32)(&MemReadCounter)");
			break;
		case 0xFE:
			fprintf(file, "(u32)(&MemReadCounter)");
			break;
		case 0xFF:
			fprintf(file, "(u32)(&MemReadCounter)");
			break;
		default:
			fprintf(file, "(u32)(&MemReadDoNothing)");
			break;
		}
		if (i == 0xFF) fprintf(file, "\n"); else fprintf(file, ",\n");
	}
	fprintf(file, "};\n");
	fclose(file);
}

int main(int argc, char* argv[]) {
	GenerateMemWriteLUT();
	GenerateMemReadLUT();
//	RegenInst();
	return 0;
}